;DublTapESC.ahk
;K. Chandler 12/2024
;
;Multiple instances not permitted, turn off warning dialog
#SingleInstance IGNORE
;
ESC_presses := 0
;
Hotkey "$Escape", ESCCount
;
;Startup Dialog
Msgbox "Double-tap ESC (2 presses) for normal ESC", "DublTapESC", "48 T6"
;
Return
;
;*****************************************************
ESCCount(ThisHotkey)
{
  global ESC_presses
  ;
  if ESC_presses > 0 
  {
    ;SetTimer has already started, so log the keypress count
    ESC_presses += 1
    ;Limit multiple ESC presses to two for an equality comparison
    if ESC_presses > 2
    {
      ESC_presses := 2
    }
  }
  else
  {
    ;Otherwise, this is the first press of a new series of ESC
    ;Set count to 1 and start the timer
    ESC_presses := 1
    ;Wait for more presses within a 250 millisecond delay
    SetTimer KeyESC, -250, 0
  }
}
;
KeyESC()
{
  ;Entering this sub means the timer has elapsed
  global ESC_presses
  if (ESC_presses == 2) 
  {
    ;Slow down the sending of Escape and send it
    SetKeyDelay 100, 25
    SendInput "{Escape}"
  }
  ;Reset the count to zero for the next series of presses
  global ESC_presses := 0
  return
}